;
;Instant Text Automator
;Author:		Desi Quintans <me@desiquintans.com>
;Website:		http://www.desiquintans.com
;
;Script Function:
;	This script lets you quickly write and use macros based on Autohotkey's Send command
;	in less time than it would take to write a new script for the same purpose. Write your
;	Send keystrokes (excluding the initial 'Send ' call) in a text box, then press the
;	hotkey associated with that text box to automatically output those keystrokes to your
;	active window at your cursor position. You can also adjust the Sleep time between Send
;	calls, or unmap the hotkeys by unchecking the 'Enable Hotkeys' checkbox.
;	Refer to http://www.autohotkey.com/docs/commands/Send.htm for how to use Send.
;

#NoEnv
#NoTrayIcon
#InstallKeybdHook
#SingleInstance Off
CoordMode, Mouse, Screen
SetWorkingDir %A_ScriptDir%
SetTitleMatchMode, 3
presentMouseX = 0
presentMouseY = 0

Gui +LastFound +OwnDialogs
GUI1 := WinExist()

Gui -MaximizeBox
	Gui, color, B0C4DE
	
	Gui, Add, GroupBox, w900 h150 Section,

		Gui, Add, Button, xm+12 ym+18 w20 h20 gInfo, ?
		Gui, Add, Text, xs+12 ys+18 w885 +Center, Press Alt+Shift+F12 to insert the mouse cursor's screen position. {AltTab} performs an alt-tab. {Wait n} to add an n millisecond delay. <// begins a comment line.

		Gui, Add, GroupBox, xm+40 ym+50 w270 h80 Section, Profile control
			Gui, Add, Checkbox, xs+20 yp+25 +Checked vENABLED gSetKeys, Enable Hotkeys
			Gui, Add, Checkbox, vREPLACE gUpdateGuiVars, Replace Mouse

			Gui, Add, Button, xp+140 yp-25 w90 h20 gSave, Save Profile
			Gui, Add, Button, xp yp+25 w90 h20 gOpen, Load Profile

		Gui, Add, GroupBox, xs+280 ys w545 h80 Section, Input method
			Gui, Add, Radio, xs+20 ys+25 vINPUTMETHOD Checked gUpdateGuiVars, Send instantly
			Gui, Add, Radio, xp yp+20 gUpdateGuiVars, Simulate typing
			
			Gui, Add, Edit, xp+140 yp-20 w80 h20 +Center +Number vLINEDELAY gUpdateGuiVars, 10
			Gui, Add, Text, xp yp+25 w80 h20 +Center, Line Delay (ms)
			
			Gui, Add, Edit, xp+140 yp-25 w80 h20 +Center +Number vKEYDELAY gUpdateGuiVars, 10
			Gui, Add, Text, xp yp+25 w80 h20 +Center, Key Delay (ms)
			
			Gui, Add, Edit, xp+140 yp-25 w80 h20 +Center +Number vPRESSTIME gUpdateGuiVars, 0
			Gui, Add, Text, xp yp+25 w80 h20 +Center, Press Time (ms)

	; Row 1
	
	gui, font
	Gui, Add, GroupBox, xm ys+120 w290 h150 Section, Bound to:
		gui, font, s10, Consolas
		Gui, Add, Hotkey, xs+57 ys-3 w90 r1 vBIND1 gSetKeys
		Gui, Add, Edit, xs+12 ys+30 w265 h107 vBINDTEXT1 gUpdateGuiVars,
	
	gui, font
	Gui, Add, GroupBox, xs+305 ys w290 h150 Section, Bound to:
		gui, font, s10, Consolas
		Gui, Add, Hotkey, xs+57 ys-3 w90 r1 vBIND2 gSetKeys
		Gui, Add, Edit, xs+12 ys+30 w265 h107 vBINDTEXT2 gUpdateGuiVars,
	
	gui, font
	Gui, Add, GroupBox, xs+305 ys w290 h150 Section, Bound to:
		gui, font, s10, Consolas
		Gui, Add, Hotkey, xs+57 ys-3 w90 r1 vBIND3 gSetKeys
		Gui, Add, Edit, xs+12 ys+30 w265 h107 vBINDTEXT3 gUpdateGuiVars,
		
	; Row 2
	
	gui, font
	Gui, Add, GroupBox, xm ys+170 w290 h150 Section, Bound to:
		gui, font, s10, Consolas
		Gui, Add, Hotkey, xs+57 ys-3 w90 r1 vBIND4 gSetKeys
		Gui, Add, Edit, xs+12 ys+30 w265 h107 vBINDTEXT4 gUpdateGuiVars,
	
	gui, font
	Gui, Add, GroupBox, xs+305 ys w290 h150 Section, Bound to:
		gui, font, s10, Consolas
		Gui, Add, Hotkey, xs+57 ys-3 w90 r1 vBIND5 gSetKeys
		Gui, Add, Edit, xs+12 ys+30 w265 h107 vBINDTEXT5 gUpdateGuiVars,
	
	gui, font
	Gui, Add, GroupBox, xs+305 ys w290 h150 Section, Bound to:
		gui, font, s10, Consolas
		Gui, Add, Hotkey, xs+57 ys-3 w90 r1 vBIND6 gSetKeys
		Gui, Add, Edit, xs+12 ys+30 w265 h107 vBINDTEXT6 gUpdateGuiVars,
	
	; Row 3
	
	gui, font
	Gui, Add, GroupBox, xm ys+170 w290 h150 Section, Bound to:
		gui, font, s10, Consolas
		Gui, Add, Hotkey, xs+57 ys-3 w90 r1 vBIND7 gSetKeys
		Gui, Add, Edit, xs+12 ys+30 w265 h107 vBINDTEXT7 gUpdateGuiVars,
	
	gui, font
	Gui, Add, GroupBox, xs+305 ys w290 h150 Section, Bound to:
		gui, font, s10, Consolas
		Gui, Add, Hotkey, xs+57 ys-3 w90 r1 vBIND8 gSetKeys
		Gui, Add, Edit, xs+12 ys+30 w265 h107 vBINDTEXT8 gUpdateGuiVars,
	
	gui, font
	Gui, Add, GroupBox, xs+305 ys w290 h150 Section, Bound to:
		gui, font, s10, Consolas
		Gui, Add, Hotkey, xs+57 ys-3 w90 r1 vBIND9 gSetKeys
		Gui, Add, Edit, xs+12 ys+30 w265 h107 vBINDTEXT9 gUpdateGuiVars,
	
	gui, font
	Gui, Add, Text, xm ys+160 w900 +Center, v12, 4 February 2014`ndesiquintans.com/automator
	
	Gui, Show, Autosize, Instant Text Automator
	GoSub, SetKeys
	ControlFocus, Edit2

OnMessage(0x200, "Help")
OnMessage(0x53, "WM_HELP")

UpdateGuiVars:
	Gui, Submit, NoHide
return

Info:
	RunWait http://www.autohotkey.com/docs/commands/Send.htm
return

SetKeys:
	Gui, Submit, NoHide
	if ENABLED = 1
	{
		Loop, 9
		{
			oldBIND%A_Index% := EnableHotkey(A_Index, oldBIND%A_Index%)
		}
	}
	else
	{
		Loop, 9
		{
			DisableHotkey(A_Index)
		}
	}
Return

EnableHotkey(BindNumber, oldBIND)
{
	HotkeyContents := BIND%BindNumber%
	HotkeyLabel = DoBind%BindNumber%
	
	Hotkey, %oldBIND%,, off UseErrorLevel
	
	Hotkey, %HotkeyContents%, %HotkeyLabel%, on UseErrorLevel
	
	return HotkeyContents
}

DisableHotkey(BindNumber)
{
	HotkeyField := BIND%BindNumber%
	
	Hotkey, %HotkeyField%,, off UseErrorLevel
}

; DOBIND labels are folded here. Explanation included.
; The Hotkey command only accepts labels as an input, so I have to call DoBind() in these
; labels rather than just directly calling DoBind() from the Hotkey commands.

DoBind1:
	DoBind(BINDTEXT1)
return

DoBind2:
	DoBind(BINDTEXT2)
return

DoBind3:
	DoBind(BINDTEXT3)
return

DoBind4:
	DoBind(BINDTEXT4)
return

DoBind5:
	DoBind(BINDTEXT5)
return

DoBind6:
	DoBind(BINDTEXT6)
return

DoBind7:
	DoBind(BINDTEXT7)
return

DoBind8:
	DoBind(BINDTEXT8)
return

DoBind9:
	DoBind(BINDTEXT9)
return

DoBind(MacroBox)
{
	global REPLACE
	global INPUTMETHOD
	global KeyDelay
	global PRESSTIME
	global LINEDELAY
	
	; This is here because each new thread (ie. each hotkey) inherits this setting.
	; Putting it anywhere except at the start of a new thread, or in the autoexecute
	; section of the script, delivers no result.
	SetKeyDelay, KeyDelay, PRESSTIME
	
	if REPLACE = 1
	{
		MouseGetPos, presentMouseX, presentMouseY
	}
	
	Loop, parse, MacroBox, `n, `r
	{
		; Commenting tag is <// Blahblahblah. Must occur at the start of a line.
		if RegExMatch(A_LoopField, "^<//") = 0
		{
			if INPUTMETHOD = 1
			{
				; SendMode Input
				SendInput %A_Loopfield%
			}
			else
			{
				; SendMode Event
				SendEvent %A_Loopfield%
			}
		    
			; Custom alt-tab tag is {AltTab} at any part of a line. It is applied at the end of the line, but before the custom {Wait} tag.
			; {AltTab} staggers its keypresses using Line Delay in Input mode, and Key Delay in Event mode.
			if RegExMatch(A_LoopField, "Pi)\{\s?AltTab\s?\}")
			{
				if INPUTMETHOD = 1
				{
					; SendMode Input
					SendInput {Alt down}
					Sleep, %LINEDELAY%
					SendInput {Tab}
					Sleep, %LINEDELAY%
					SendInput {Alt up}
				}
				else
				{
					; SendMode Event
					SendEvent {Alt down}
					Sleep, %KeyDelay%
					SendEvent {Tab}
					Sleep, %KeyDelay%
					SendEvent {Alt up}
				}
			}
		    
		    ; Custom pause tag is {Wait NUMBER} at any part of a line. It is automatically
		    ; ignored by AHK if it occurs within a macro's text. The pause is applied only
		    ; at the end of the line it is found on.
			if RegExMatch(A_LoopField, "i)\{\s?Wait\s?([0-9]*)\s?\}", PlusDelay) != 0
			{
				Sleep, PlusDelay1
			}
			else
			{
				Sleep, LINEDELAY
			}
		}
	}
	
	if REPLACE = 1
	{
		Send, {Click %presentMouseX%, %presentMouseY% 0}
	}
}

Open:
	FileSelectFile, openfilename,3,,Load a profile - Instant Text Automator, Configuration file (*.ini)
	if ErrorLevel = 0
	{
		if openfilename != ""
		{
			IniRead, newREPLACE, %openfilename%, General, ReplaceMouse, 0
				GuiControl,, REPLACE, %newReplace%
				
			IniRead, newLINEDELAY, %openfilename%, General, LineDelay, 10
				GuiControl,, LINEDELAY, %newLINEDELAY%
			
			IniRead, newINPUTMETHOD, %openfilename%, General, InputMethod, 1
				if newINPUTMETHOD = 1
				{
					GuiControl,, Button9, 1
				}
				else
				{
					GuiControl,, Button10, 1
				}
				
			IniRead, newKEYDELAY, %openfilename%, General, KeyDelay, 10
				GuiControl,, KEYDELAY, %newKEYDELAY%

			IniRead, newPRESSTIME, %openfilename%, General, PRESSTIME, 0
				GuiControl,, PRESSTIME, %newPRESSTIME%

			Loop, 9
			{
				; Since my fields and sets are sequentially numbered, I can do this and avoid repeating myself. How neat!
				LoadMacroFromProfile("BIND" . A_Index, "BINDTEXT" . A_Index, openfilename, "Set" . A_Index)
			}
	
			GoSub, SetKeys
			
			SplitPath, openfilename,,,, OutNameNoExt
			Gui, Show, Autosize, Instant Text Automator (Profile: %OutNameNoExt%)
		}
	}
return

LoadMacroFromProfile(HotkeyField, MacroBoxField, Profile, SetNumber)
{
	; Read and import the hotkey.
	IniRead, newBIND, %Profile%, %SetNumber%, Shortcut, %A_SPACE%
	GuiControl,, %HotkeyField%, %newBIND%
	
	; Read and import the macro box. Replace the newline and apostrophe escape sequences I made up with their proper chars.
	IniRead, newBINDTEXT, %Profile%, %SetNumber%, Command, %A_Space%
	StringReplace, newBINDTEXT, newBINDTEXT, <````n>, `n, All
	StringReplace, newBINDTEXT, newBINDTEXT, <````'>, ', All
	GuiControl,, %MacroBoxField%, %newBINDTEXT%
}

Save:
	if OutNameNoExt ; If a file is currently open
	{
		defaultFilename := OutNameNoExt
	}
	else
	{
		defaultFilename = %A_WorkingDir%\%A_DD% %A_MMM% %A_YYYY% %A_Hour%%A_Min%
	}
	
	FileSelectFile, savefilename, S24, %defaultFilename%.ini, Save your profile - Instant Text Automator, Configuration file (*.ini)
	
	if ErrorLevel = 0
	{
		if savefilename != ""
		{
			if RegExMatch(savefilename, "(.ini)$") = 0
			{
				savefilename = %savefilename%.ini
			}
			FileDelete, %savefilename%
			
			IniWrite, %REPLACE%, %savefilename%, General, ReplaceMouse
			IniWrite, %LINEDELAY%, %savefilename%, General, LineDelay
			IniWrite, %INPUTMETHOD%, %savefilename%, General, InputMethod
			IniWrite, %KEYDELAY%, %savefilename%, General, KeyDelay
			IniWrite, %PRESSTIME%, %savefilename%, General, PressTime
			
			Loop, 9
			{
				WriteMacroToProfile(A_Index, "BINDTEXT" . A_Index, savefilename, "Set" . A_Index)
			}
			
			SplitPath, savefilename,,,, OutNameNoExt
			Gui, Show, Autosize, Instant Text Automator (Profile: %OutNameNoExt%)
		}
	}
return

WriteMacroToProfile(HotkeyFieldNumber, MacroBoxContents, Profile, SetNumber)
{
	; Using Bind%HotkeyFieldNumber% by itself in IniWrite simply writes the literal "BIND[number]" to the profile.
	HotkeyField := BIND%HotkeyFieldNumber%
	IniWrite, %HotkeyField%, %Profile%, %SetNumber%, Shortcut
	StringReplace, encodedMacroBoxContents, %MacroBoxContents%, `n, <````n>, All
	StringReplace, encodedMacroBoxContents, encodedMacroBoxContents, ', <````'>, All
	IniWrite, %encodedMacroBoxContents%, %Profile%, %SetNumber%, Command
}

!+F12::
	MouseGetPos, mouseX, mouseY
	WinActivate, Instant Text Automator
		; Nested brackets are for printing { and } characters as plain text.
	Send {{}Click %mouseX%, %mouseY%{}}{Enter}
return

Help(wParam, lParam, Msg)
{
	; This tooltip code is from Alpha Bravo, http://www.autohotkey.com/board/topic/81915-solved-gui-control-tooltip-on-hover/#entry520741
	MouseGetPos,,,, OutputVarControl
	
	IfEqual, OutputVarControl, Button2
		Help := "Open the Send command reference page (autohotkey.com)."

	else IfEqual, OutputVarControl, Button4
		Help := "Enable or disable all hotkeys without unbinding them."

	else IfEqual, OutputVarControl, Button5
		Help := "Put the mouse cursor back in its original position when the macro is finished."

	else IfEqual, OutputVarControl, Button6
		Help := "Save this panel of macros for later use."
		
	else IfEqual, OutputVarControl, Button7
		Help := "Load a previously-saved panel of macros."

	else IfEqual, OutputVarControl, Button9
		Help := "All keystrokes written on a single line will be sent instantly."
		
	else IfEqual, OutputVarControl, Button10
		Help := "All keystrokes will be typed out as if by a human."

	else IfEqual, OutputVarControl, Edit1
		Help := "How many milliseconds to wait before running the next line in the macro. Applies to both input methods."
		
	else IfEqual, OutputVarControl, Static2
		Help := "How many milliseconds to wait before running the next line in the macro. Applies to both input methods."
		
	else IfEqual, OutputVarControl, Edit2
		Help := "How many milliseconds to wait between keypresses. Applies only to the 'Simulate typing' input method."
		
	else IfEqual, OutputVarControl, Static3
		Help := "How many milliseconds to wait between keypresses. Applies only to the 'Simulate typing' input method."
		
	else IfEqual, OutputVarControl, Edit3
		Help := "How many milliseconds each key should be held down, which some programs require.`nThis doesn't appear to trigger key repeating.`nApplies only to the 'Simulate typing' input method."
		
	else IfEqual, OutputVarControl, Static4
		Help := "How many milliseconds each key should be held down, which some programs require.`nThis doesn't appear to trigger key repeating.`nApplies only to the 'Simulate typing' input method."
	
	ToolTip % Help
}

GuiClose:
ExitApp